/****************************************************
 *
 *
 * TEST
 *
 * TESTING reading from SD Cards
Change from Mod5270 to Nano54415
Derives from Nano54415 version, now ver 2

CHANGED from compiler 2.9.5 to 3.3.9   CODE only works on ARM now.

Christmas shows sent to Sandevices gear over ethernet.
1-21 - added TREE to read patterns from SDCard and output to tree.


****************************************************/
#include "predef.h"
#include <stdio.h>
#include <ctype.h>
#include <startnet.h>
#include <ethernet.h>
#include <ethervars.h>
//#include <autoupdate.h>
#include <NetworkDebug.h>
#include <udp.h>
#include <dhcpclient.h>
#include <stdlib.h>
#include <basictypes.h>
#include <serial.h>
#include <system.h>
#include <constants.h>
//#include <ucos.h>
#include <nbrtos.h>
#include <init.h>
#include <smarttrap.h>
#include <taskmon.h>
#include <sim.h>
//#include <pins.h>
#include <NetworkDebug.h>
#include <nbtime.h>
#include <utils.h>              // Include for LED writes on carrier board
#include <constants.h>          // Include for constands like MAIN_PRIO
#include <system.h>             // Include for system functions
#include <pins.h>
//#include <rtc.h>
#include <mcf5441x_rtc.h>
#include <nbtime.h>
//#include <cfinter.h>  // INTERRUPTS
#include <string.h>
// SDCard
#include <effs_fat/fat.h>
#include "FileSystemUtils.h"
#include <StopWatch.h>
#include "xmas2011.h"
#include "shows.h"
#include "E682.h"
#include "sdcard.h"
// TELNET Jul 5 2022
#include <tcp.h>
#include <fdprintf.h>

const char * AppName="NanoXmas2023";

#define DEBUG 0  /* turns on debuggin */
#define SEED 0xbeefdead /* to set SRAND) */
#define MINUTE 60
#define FUDGEMINUTE 25

int universecount, countSecs;

//extern int debugint, qspifunction;
//extern int qspipasscount, endtranscount, qspibrightcount;
static volatile unsigned timeout;
time_t systime;
char teststr[16];
int numfullbright = 60; // one minute of fullbright being enabled
int delaytsu;
struct tm *rtctime;
int noPacketFlag = FALSE;
//extern pixel outpixels[NUMETHLIGHTS];
int tempint;
int portnum;
unsigned char tempchar;
//extern unsigned char sequenceout[512]; // one per universe to speed up code
char buffer[255];
char trash[128];
char *bufferptr;
int ForceGroup = 0, ForceProg = 0;
int NoFlashyFlag = 0;
extern int i;
int HolidayType = 1;
int SleepFlag;
int fd;
#define TCP_LISTEN_PORT 23   // Telnet port number
#define RX_BUFSIZE (4096)
char RXBuffer[RX_BUFSIZE];
const char *dow_str[] =
{
  "SUN", "MON", "TUE", "WED", "THU", "FRI", "SAT", "\0"
};

/*  CODE */

extern "C" {
void UserMain(void * pd);
}
/*-------------------------------------------------------------------------------
 * Write time to the screen
 *-------------------------------------------------------------------------------*/
void PrintTimeStruct(struct tm &bt)
{
    iprintf("%d/%d/%d day: %d (%s) %02d:%02d:%02d", bt.tm_mon + 1, bt.tm_mday, bt.tm_year + 1900, bt.tm_yday,
            dow_str[bt.tm_wday], bt.tm_hour, bt.tm_min, bt.tm_sec);
}
/*-------------------------------------------------------------------------------
 * Display system time
 *-------------------------------------------------------------------------------*/
void DisplayRtcTime()
{
    struct tm calendarTime;     // calendar time
    time_t epochTime;            // time since epoch

    epochTime = time(NULL);     // the current time of the system as time since the epoch
    // converts time since the epoch to calendar time expressed as Coordinated Universal Time (UTC)
    gmtime_r(&epochTime, &calendarTime);
    iprintf("UTC Time: ");
    PrintTimeStruct(calendarTime);
    iprintf("\r\n");
}
void displayMenu(int32_t ffdAccept)
{
	iprintf("\r\n----- Main Menu -----\r\n");
//    iprintf("A - Show ARP Cache\r\n");
//    iprintf("C - Show Counters\r\n");
//    iprintf("E - Show Ethernet Registers\r\n");
	iprintf("F - Force Group to Program number.  F x y  \r\n");
#ifdef UCOS_TASKLIST
    iprintf( "H - Show Task Changes\r\n" );
#endif // UCOS_TASKLIST

    iprintf("I - Change Flashy Flag on/off\r\n");
    iprintf("N - Filenames on SDCard\r\n");
    iprintf ("O - ON OFF\r\n");

#ifdef _DEBUG
    iprintf( "L - Set Up Debug Log Enable(s)\r\n" );
#endif // _DEBUG

//    iprintf("P - Ping (Example: \"P 192.168.1.1\")\r\n");

#ifdef UCOS_STACKCHECK
    iprintf( "S - Show OS Task Stack Info\r\n" );
    iprintf( "U - Show OS Task Info\r\n" );
#endif // UCOS_STACKCHECK

 //   iprintf( "S - SDCard Mount and directory\r\n" );
    iprintf( "T - Time and Date display\r\n" );
    iprintf( "C - Current programs and settings\r\n" );

//    iprintf("W - Show OS Seconds Counter\r\n");
    iprintf("? - Display Menu\r\n");

//    showEthernetLinkStatus();
}
void processCommand(char *buffer, int32_t ffdAccept)
{
//    struct tm calendarTime;     // calendar time
//    int result;
    double funcTime;
    StopWatch myStopWatch;

    switch (toupper(buffer[0]))
    {
    case 'C': // Current
    	if (NoFlashyFlag)
    		iprintf("NOFLASHY mode\r\n");
    	if (HolidayType)
    		iprintf("Holiday is %d\r\n", HolidayType);
    	i=0;
    	tempint = SmellCurrentShow(i);
    	while (tempint != 0)
    	{
    		funcTime = TimeCurrentShow(i);
    		iprintf("Show %d - %d in %f sec\r\n", i, tempint, funcTime);
    		i+=1;
    		tempint = SmellCurrentShow(i);
    	}
  	  break;

    case 'F': // Force X Y  means force group X to program Y
  	  sscanf(buffer,"%s %d %d", trash, &ForceGroup, &ForceProg);
  	  break;


    case 'I': // NO flashy programs
      if(NoFlashyFlag == 0)
      	{
      	NoFlashyFlag = 1;
      	iprintf("NOFLASHY mode\r\n");
      	}
      else
      	{
      	NoFlashyFlag = 0;
      	iprintf("Normal mode\r\n");
      	}
      break;

    case 'N':
    	SmellFilenames();
    	break;

    case 'O':
    	if (SleepFlag)
    		SleepFlag = 0;// wake up
    	else
    		SleepFlag = 2; // order to go to sleep
    	break;

    case 'T':
  		DisplayRtcTime();
/*        iprintf("Time: ");
      	iprintf("%d/%d/%d day: %d (%s) %02d:%02d:%02d", calendarTime.tm_mon + 1, calendarTime.tm_mday, calendarTime.tm_year + 1900, calendarTime.tm_yday,
      	            dow_str[calendarTime.tm_wday], calendarTime.tm_hour, calendarTime.tm_min, calendarTime.tm_sec);
      	iprintf("\r\n");
*/
        break;
/*
    case 'S': // 'S'

    	f_enterFS();
//    	InitExtFlash();   // Initialize the CFC or SD/MMC external flash drive
    	InitMYSD();
//    	DumpDir();                 // Display flash card files and directories
    	myStopWatch.Start();
    	GetSDDir(1); //
    	iprintf("Time needed %f\r\n", myStopWatch.Convert(myStopWatch.Stop()));
    	UnmountExtFlash();
    	SmellFilenames();
       break;
*/
    case '?': // '?'
    	  displayMenu(ffdAccept);
       break;
    }
}

/*-------------------------------------------------------------------------------
 * Main Loop
 *-------------------------------------------------------------------------------*/
void UserMain(void * pd)
{
//    InitializeStack();
    init();                                       // Initialize network stack
    //Enable system diagnostics. Probably should remove for production code.
    EnableSystemDiagnostics();
//    StartHttp();                                  // Start web server, default port 80
    WaitForActiveNetwork(TICKS_PER_SECOND * 5);   // Wait for DHCP address

    iprintf("Application: %s\r\nNNDK Revision: %s\r\n", AppName, GetReleaseTag());
// force all serial comm traffic out port 1
//    SerialClose(0);
 //   fd = OpenSerial(1, 115200, 1, 8, eParityNone );
//    ReplaceStdio(0, fd);
//    ReplaceStdio(1, fd);
//    ReplaceStdio(2, fd);

    initshows();
    OSChangePrio(MAIN_PRIO);
	ResetEthDesc();
	iprintf("Getting time from NTP\r\n");
	if ( SetTimeNTPFromPool() )
	    {
	    iprintf("Time set\r\n");
//	    MCF541X_RTCSetRTCfromSystemTime();
	    }

	iprintf("Starting NanoXmas2023 \r\n");
	portnum = 5568; // port E1.31 is always this port

	universecount = 0;
	countSecs = 0;
	SleepFlag = 0;

//	DisplayRtcTime();
	timeout =  time(NULL);
	srand( (unsigned)timeout);
	iprintf("Seed = %d\n",timeout);
	timeout=0;

	// START using the SDCard to have patterns for the Tree
	iprintf("Entering SDcard\r\n");
	f_enterFS(); // init the file system
	InitMYSD(); // initialize things.
	GetSDDir(0);  // find all the filenames on the SDCard
	iprintf("Entering Endless Loop\r\n");
	RandomTree(0);

    while (1)  // start endless loop
    	{
    	OSTimeDly( TICKS_PER_SECOND / 20 ); // There are 20 ticks per second
    	OutputTree(0);
    	} // WHILE 1
}
