// Xmas2011code
//
// Allen Kitchen, Oct 2009
//
// functions and data structures to display 8 RGB LED bars
// dec 24 2011 -- fixed limiter in setlight -- a negative input would cause crazy lights.
// dec 02 2012 00 added bitwise protection in setlight
// Mar 2013 - made it so it'll drive ethernet lights too.
// Jan 2017 - COMPLETE removal of spi code

#include "predef.h"
#include <stdio.h>
#include <ctype.h>
#include <basictypes.h>
//#include <serialirq.h>
#include <system.h>
#include <constants.h>
//#include <ucos.h>
//#include <SerialUpdate.h>
//#include <..\MOD5270\system\sim5270.h>  // 5270 structure
//#include <bsp.h>                // 5213 board support package interface
#include <smarttrap.h>          // NetBurner Smart Trap utility
#include <utils.h>              // Include for LED writes on carrier board
#include <constants.h>          // Include for constands like MAIN_PRIO
#include <system.h>             // Include for system functions
#include <pins.h>
//#include <cfinter.h>  // INTERRUPTS
#include <string.h> // for Memcpy
//#include <qspi.h>
//#include "QSPIconstants.h"
#include "xmas2011.h"

pixel outpixels[NUMETHLIGHTS];
INT16 outbufferONOFF[NUMINTSONOFF];
INT16 outbuffer[NUMINTS], drivebuffer[NUMINTS+NUMINTSONOFF], drivercommand[NUMLIGHTS]; // double buffer output
int qspipasscount, endtranscount, intDelay, disptempint, qspibrightcount;
INT16 brightness;
int tempi;

int qspifunction;
int debugint;

pixel * pixelptr;

void saybuffsize()
{
	iprintf("Ethernet Only");
	iprintf("Now running NanoXmas2023");
}
void setonoff(int pos)
{
static UINT16 soindex, sopattern;

soindex = pos >> 4;
sopattern = (0x0001 << (pos&0x000f));
outbufferONOFF[soindex] |= sopattern;
}

void setlight(int pos, INT16 setRed, INT16 setGrn, INT16 setBlu)
{
//static INT16 slindex, slhigh, sllow; /* static for speed sake*/
//static LONG sltempINT16, sllsl;
//	register pixel * pixelptr;

if (pos<0)
	return;
if (setGrn>1023)
	setGrn = 1023;
if (setGrn<0)
	setGrn = 0;
if (setRed>1023)
	setRed = 1023;
if (setRed<0)
	setRed = 0;
if (setBlu>1023)
	setBlu = 1023;
if (setBlu<0)
	setBlu = 0;

if (pos>NUMETHLIGHTS)
		{
		return; // bad index
		}
pixelptr = &outpixels[pos];
//outpixels[pos].red = (unsigned char)(setRed>>2);
//outpixels[pos].grn = (unsigned char)(setGrn>>2);
//outpixels[pos].blu = (unsigned char)(setBlu>>2);
pixelptr->red = (unsigned char)(setRed>>2);
pixelptr->grn = (unsigned char)(setGrn>>2);
pixelptr->blu = (unsigned char)(setBlu>>2);
}

void clearlights( int start, int number)
{
//static INT16 * clptr;
static pixel * clptr2;

if (start<0)
	return;
if (start>=NUMETHLIGHTS)
		{
		return; // bad index
		}

clptr2 = &outpixels[start];
number *= 3; // 3 bytes per light
memset(clptr2, 0x00, number); // 3 bytes per light; 24bits
}

void copylights(int from , int to)
{
static char *fromptr, *toptr;

fromptr = (char*) &outpixels[from];
toptr = (char*) &outpixels[to];
memcpy(toptr, fromptr, 3); // 3 bytes per light;
}

void clearallonoff()
{
	static INT16 coa;

	for (coa = 0; coa < NUMINTSONOFF; coa++)
		{
		outbufferONOFF[coa] = 0;
		}
}
void clearonoff(int pos, int count)
{
	static UINT16 coindex, copattern;
	static INT16 co;
	for (co = pos; co <pos+count; co++)
		{
		coindex = co >> 4;
		copattern = (0x0001 << (co%16));
		outbufferONOFF[coindex] &= ~copattern;
		}
}

void setlightchar(int pos, unsigned char setRed, unsigned char setGrn, unsigned char setBlu)
{
//register pixel * pixelptr;

if (pos<0)
	return;
if (pos>NUMETHLIGHTS)
		{
		return; // bad index
		}
pixelptr = &outpixels[pos];
pixelptr->red = setRed;
pixelptr->grn = setGrn;
pixelptr->blu = setBlu;
}
